<?php
namespace App\Http\Controllers\TipUser;

use App\Http\Controllers\Controller;
use App\Models\DropInSession;
use App\Models\DropInSessionDetail;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class DropinSessionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $session=DropInSession::get();
        return view('tip-users.session.index', compact('session'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $session=new DropInSession();
        $session->start_date=$request->start_date;
        $session->start_time=$request->start_time;
        $session->duration=$request->duration;
        $session->clinician=$request->clinician;
        $session->zoom_link=$request->zoom_link;
        $session->status=$request->status;
        $session->updated_by=Auth::user()->id;
        $session->save();
        return back()->with('success' , 'Submitted Successfully');

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function session_detail(Request $request)
    {
        $detail=new DropInSessionDetail();
        $detail->dropin_session_id=$request->dropin_session_id;
        if($request->generate_ticket=="Y"){
            $detail->volunteer_id=$request->volunteer_id;
            $detail->client_id=$request->client_id;
            $detail->notes=$request->notes;
            $detail->generate_ticket=$request->generate_ticket;
            $detail->ticket_title=$request->ticket_title;
            $detail->ticket_priority=$request->ticket_priority;
            $detail->ticket_desc=$request->ticket_desc;
      
        }
        else{
            $detail->volunteer_id=$request->volunteer_id;
            $detail->client_id=$request->client_id;
            $detail->notes=$request->notes;
        }

        $detail->updated_by=Auth::user()->id;
        $detail->save();
        return back()->with('success' , 'Updated Successfully');


    }
     

}
