<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateTrainingFeedbackTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('training_feedback', function (Blueprint $table) {
            $table->id();
            $table->text('recruitment_process')->nullable();
            $table->text('comprehensible')->nullable();
            $table->string('timely_fashion')->nullable();
            $table->text('recruitment_experience')->nullable();
            $table->string('team_member_name')->nullable();
            $table->text('specific_feedback')->nullable();
            $table->string('commitment_months')->nullable(); 
            $table->text('session_topic')->nullable();
            $table->text('feedback_interaction')->nullable();
            $table->text('recommendations')->nullable();
            $table->text('communication_quality')->nullable();
            $table->text('modality_communication')->nullable();
            $table->string('teammate')->nullable();
            $table->string('adequate_level')->nullable();
            $table->text('hotline_addressed')->nullable();
            $table->text('hotline_feedback')->nullable();
            $table->integer('volunteer_id');
            $table->integer('training_batch');
            $table->date('availabe_till_date');     
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('training_feedback');
    }
}
